/* 								  
 *
 *  	FILENAME: 			P9143 LTPS FM
 *
 *  	DRIVER:    			L1K0
 *    	DESCRIPTION:	    Full Module Program P9143 LTPS digital 3.5"
 *
 *    	AUTHOR:				Conrad Ching
 *    	HISTORY:    		
 * 		Ver2.a			  	FMT program is use already, change project name from P9143 to P9457
 *		Ver3.a				pattern change automatically, pause by halt_button
 *
 *
 * 
 *      
 *************************************************************************************/
rom unsigned char Program12nc[] = "520004286A";
rom unsigned char Project[] = "DJ035xx BCRMS";
rom unsigned char Date[] = "20111020";

#include "TestProgramV2_1_1.h"
float  X,Y,Z;

extern void uart_putchar(unsigned char);
extern void uart_init(void);

extern unsigned char read_rgb(float rgb[3]);
extern unsigned char read_rgb2(float *x,float *y,float *z);
extern float read_flick(void);

#define interface	rgb
//*************************************************************************************
// Control lines
//*************************************************************************************
#define CLK			Ocont_0
#define DE			Ocont_1
#define HS			Ocont_2
#define VS			Ocont_3
#define send_wait       200

//*************************************************************************************
// Data lines
//*************************************************************************************
#define D0	  		IOdata_0		 //R0	 A5 
#define D1	  		IOdata_1		 //R1	 B5
#define D2	  		IOdata_2		 //R2	 A6
#define D3	  		IOdata_3		 //R3	 B6
#define D4	  		IOdata_4  		 //R4	 A7
#define D5	  		IOdata_5		 //R5	 B7
#define D6	  		IOdata_6  		 //G0	 A8
#define D7	  		IOdata_7		 //G1	 B8
#define D8	  		IOdata_8  		 //G2	 A9
#define D9	  		IOdata_9		 //G3	 B9
#define D10	  		IOdata_10		 //G4	 A10
#define D11	  		IOdata_11  		 //G5	 B10
#define D12	  		IOdata_12		 //B0	 A11
#define D13	  		IOdata_13  		 //B1	 B11
#define D14	  		IOdata_14		 //B2	 A12
#define D15	  		IOdata_15		 //B3	 B12
#define D16	  		Odata_16  		 //B4	 A13
#define D17	  		Odata_17		 //B5	 B13
#define RL			Odata_19		 //High = D1 -> D320
#define TB			Odata_21		 //High = Top -> Bottom

#define CSB			Odata_20
#define SCL			Odata_23
#define SDA			Odata_22

#define BL_EN		SlowIO_7		//backlight enable H=enable L=disable
#define DIM			Ocont_4			//dimming control
#define NTC			Odata_18		// NTC pin

#define ALLIODATA1	0xFFFFFF 

//*************************************************************************************
// Analog outputs
//*************************************************************************************
#define VDD				Vout_4
#define I_VDD			I_Vout4
#define I_BL			Ain16
#define V_BL			Ain15
#define SHUNT_R			0.41		// Two 0.82 ohm resistor in parallel
									// Farnell order code: 3104709
#define LOOP1          VoutM1
#define LOOP2          Ain7
//*************************************************************************************
//   OUTPUT values Hardware
//*************************************************************************************
#define vdd			3.3
#define VOPEN		-0.65
#define	VTRESHOLD	1.1

//*************************************************************************************
//	Limits for current measurements TFT
//*************************************************************************************
#define    	idd_por_min					5E-6   		// 		         
#define    	idd_por_max					200E-6  	//
#define 	i_led_min					120E-3
#define		i_led_max					300E-3 		 

#define		i_flicker_min				30.2E-3
#define		i_flicker_max				45.2E-3
#define		i_frame_min					28.5E-3
#define		i_frame_max					47.4E-3
#define		i_red_min					27.1E-3
#define		i_red_max					46.3E-3
#define		i_green_min					27.1E-3
#define		i_green_max					46.4E-3
#define		i_blue_min					29.4E-3
#define		i_blue_max					48.2E-3
#define		i_black_min					28.6E-3
#define		i_black_max					47.4E-3
#define		i_white_min					26.5E-3
#define		i_white_max					44.1E-3
#define		i_h_grey_bars_min			28.3E-3
#define		i_h_grey_bars_max			46.3E-3
#define		i_v_grey_bars_min			28.0E-3
#define		i_v_grey_bars_max			45.6E-3
#define		i_h_color_bars_min			28.5E-3
#define		i_h_color_bars_max			47.1E-3
#define		i_v_color_bars_min			29.0E-3
#define		i_v_color_bars_max			45.7E-3
#define		i_chess_min					31.0E-3
#define		i_chess_max					51.0E-3
#define		i_checker_flag_min			28.1E-3
#define		i_checker_flag_max			45.6E-3
#define 	i_module_min				31.0E-3
#define 	i_module_max				51.0E-3

#define		NTC_min						249E-6		// at 18deg C
#define		NTC_max						2.0E-3		// at 80deg C

//*************************************************************************************
// input short and open limits
//*************************************************************************************
#define	ISHORT_LOW_OFS_MIN			   	-2000E-6 
#define	ISHORT_LOW_OFS_MAX			  	2000E-6 
#define	ISHORT_LOW_REL_MIN			   	-2000E-6 
#define	ISHORT_LOW_REL_MAX			  	2000E-6 
#define	ISHORT_HIGH_OFS_MIN			   	-2000E-6 
#define	ISHORT_HIGH_OFS_MAX			  	2000E-6 
#define	ISHORT_HIGH_REL_MIN			   	-2000E-6 
#define	ISHORT_HIGH_REL_MAX			  	2000E-6 
#define	IOPEN_MIN			   			-2000E-6 
#define	IOPEN_MAX			  			2000E-6 

//********************************************************************************
// Global Variable
//********************************************************************************
unsigned int reg_data;
_bit     first_flag=1;

//********************************************************************************
// Definition of displays
//********************************************************************************
unsigned char xdat rgb[32];  
unsigned char xdat rgb_high[32];
unsigned char xdat rgb_low[32];
unsigned char xdat rgb655[32];  
unsigned char xdat rgb556[32];  

//********************************************************************************
// Definition of bitmaps
//********************************************************************************
unsigned char xdat spi[32];
unsigned char xdat no_clk[32];
unsigned char xdat unicolor[32];
unsigned char xdat unicolor_low[32];
unsigned char xdat unicolor_high[32];
unsigned char xdat bird[32];
unsigned char xdat flicker_dot[32];
unsigned char xdat frame[32];
unsigned char xdat red[32];   
unsigned char xdat green[32];
unsigned char xdat blue[32];   
unsigned char xdat black[32];   
unsigned char xdat white[32];   
unsigned char xdat h_grey_bars[32];
unsigned char xdat v_grey_bars[32];
unsigned char xdat h_color_bars[32];
unsigned char xdat v_color_bars[32];
unsigned char xdat chess[32];
unsigned char xdat checker_flag[32];
unsigned char xdat strip[32];
unsigned char xdat h_grey_color_bars[32];
unsigned char xdat v_grey_color_bars[32];
/*
unsigned char xdat grey15[32];
unsigned char xdat grey31[32];
unsigned char xdat grey47[32];
unsigned char xdat half_red[32];   
unsigned char xdat half_green[32];
unsigned char xdat half_blue[32];   
unsigned char xdat window[32];
unsigned char xdat flicker_line[32];
*/
									
//********************************************************************************
void Initialise_Names(void)
{
    romstrcpy( rgb	  		, "p9143" );
    romstrcpy( bird			, "320x240_bird.bmp" );

    romstrcpy( flicker_dot	, "320x240_flicker_dot.bmp" );
    romstrcpy( frame		, "320x240_frame.bmp" );
    romstrcpy( red 			, "320x240_red.bmp" );
    romstrcpy( green		, "320x240_green.bmp" );
    romstrcpy( blue		    , "320x240_blue.bmp" );
    romstrcpy( black 		, "320x240_black.bmp" );
    romstrcpy( white		, "320x240_white.bmp" );
    romstrcpy( h_grey_bars		, "320x240_h_64grey_bars.bmp" );
    romstrcpy( v_grey_bars		, "320x240_v_64grey_bars.bmp" );
    romstrcpy( h_color_bars		, "320x240_h_color_bars.bmp" );
    romstrcpy( v_color_bars		, "320x240_v_color_bars.bmp" );
    romstrcpy( chess			, "320x240_chess.bmp" );
    romstrcpy( checker_flag		, "320x240_checker_flag.bmp" );
    romstrcpy( strip			, "320x240_strip.bmp" );
/*  romstrcpy( h_grey_color_bars, "320x240_h_grey_color_bars.bmp" );
    romstrcpy( v_grey_color_bars, "320x240_v_grey_color_bars.bmp" );
	romstrcpy( grey15			, "320x240_grey15.bmp" );
    romstrcpy( grey31			, "320x240_grey31.bmp" );
    romstrcpy( grey47			, "320x240_grey47.bmp" );
    romstrcpy( half_red  		, "320x240_half_red.bmp" );
    romstrcpy( half_green		, "320x240_half_green.bmp" );
    romstrcpy( half_blue    	, "320x240_half_blue.bmp" );
    romstrcpy( window			, "320x240_window.bmp" );
    romstrcpy( flicker_line		, "320x240_flicker_line.bmp" );
*/ 
}

//********************************************************************************
void Init_Power(void)
{
 	Out_Dac(VDD,vdd);
   	Out_Dac(V_Low,0);
	Out_Dac(V_High,vdd);
 	Set_Slow(BL_EN);
 	Wait(100);
}
//********************************************************************************
void Reset_Power(void)
{
	Reset_Slow(BL_EN);
    Out_Dac(VDD,0);
    Out_Dac(V_Low,0);
    Out_Dac(V_High,0);
    Wait(100);
}
//********************************************************************************
signed char Init_Protocol(unsigned char xdat *Driver_Name)
{

	if (!strcmp(Driver_Name, rgb))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 							// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM); 	//Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("7.5MHz");
    }
    else if (!strcmp(Driver_Name, rgb_low))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(6000);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 384;									// Total number of clock pulses per line
		iRgblinesFrame = 260;									// Total number of lines within frame
		cRgbHorPos = 24;										// Horizontal start position of display line
		cRgbVerPos = 3; 										// Vertical start position of display line
		cRgbHorSync = 3;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 1;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("6.0MHz");
    }
    else if (!strcmp(Driver_Name, rgb_high))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(8890);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 436;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 100;										// Horizontal start position of display line
		cRgbVerPos = 20; 										// Vertical start position of display line
		cRgbHorSync = 80;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 3;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("8.89MHz");
    }
    else if (!strcmp(Driver_Name, unicolor))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);
    }
    else if (!strcmp(Driver_Name, unicolor_low))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(6000);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 384;									// Total number of clock pulses per line
		iRgblinesFrame = 260;									// Total number of lines within frame
		cRgbHorPos = 24;										// Horizontal start position of display line
		cRgbVerPos = 3; 										// Vertical start position of display line
		cRgbHorSync = 3;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 1;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

		Display_Message("6MHz unicolor");
		Wait(800);
    }
    else if (!strcmp(Driver_Name, unicolor_high))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(8890);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 436;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 100;										// Horizontal start position of display line
		cRgbVerPos = 20; 										// Vertical start position of display line
		cRgbHorSync = 80;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 3;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);
	
		Display_Message("8.89MHz unicolor");
		Wait(800);
    }
	else if (!strcmp(Driver_Name, no_clk))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 							// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM); 	//Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL+CLK);						// Switch lines to protocol
		SetDigital(CSB+SCL+DIM);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("no clk Init");
    }
	else if (!strcmp(Driver_Name, spi))
    {
		EnableInput(0,0);
		OutputDigital(CSB+SCL+SDA+DIM);
		SelectDigitalSoftwareControl(ALLIODATA);
		lEnable_SCE = CSB;
		lEnable_DC = 0;
		lEnable_CLK = SCL;
		lEnable_DAT = SDA;
		lEnable_INDAT = 0;
		cProtocol = cProtocol_Serial_Word;
		cSerialCtrlReg = CS_LOW + CLOCK_UP + CLOCKIDLE_HIGH + MSB_FIRST + DC_AFTERDATA + DATA_COMNOT + NOSERIAL_DC;
//		cSerialCtrlReg = 0x29;
		cNrSerialBits = 16;
//		SetFrequency(1000);					// 500kHz SCL
		SetFrequency(160);					// 80kHz SCL
		SelectDigitalSoftwareControl(!CSB+!SCL+!SDA+DIM+CLK);
		
		Display_Message("spi init");
	}
    else
    {
        Display_Message("Wrong Driver Name in Init_protocol");
        return -1;
    }
    return 0;
}
//********************************************************************************
signed char Reset_Driver(unsigned char xdat *Driver_Name)
{
    if (!strcmp(Driver_Name, interface))
    {
        
    }
    else
    {
        Display_Message("Wrong Driver Name in Reset_Driver");
        return -1;
    }
    return 0;
}
//*************************************************************************************
signed char Init_Driver(unsigned char xdat * Driver_Name)
{   
    if (!strcmp(Driver_Name, interface))
    {
        	
    } 
    else
    {
        Display_Message("Wrong Driver Name in Init_Driver");
        return -1;
    }
    return 0;

} 

//*************************************************************************************
signed char Display_Bitmap(unsigned char xdat *Display_Name,unsigned char xdat *Bitmap_Name)
{
    struct bitmapheader xdat *Header;
    if (!Program_Aborted)
    {
        if ((Header = Select_Ram_Bitmap(Display_Name,Bitmap_Name)))
        {
 		     Start_Bitmap();
			 SetDigital(DIM);
        }
        else
        {
            Display_Message ("Unknown display or bitmap");
            return -1;
        }
    }
    return 0;
}

//*************************************************************************************
void Display_UniColor(unsigned char Red,unsigned char Green, unsigned Blue)
{
	#define LSBRedBit   0x100000	// points to the LSB of the Red color
	#define LSBGreenBit 0x004000	// points to the LSB of the Green color
	#define LSBBlueBit  0x000100	// points to the LSB of the Blue color

	long Result;

	Init_Protocol(unicolor);
	Result = (long)Red*LSBRedBit + (long)Green*LSBGreenBit + (long)Blue*LSBBlueBit; 
	ResetDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17);
	SetDigital(Result);
}

 void flicker_measure(void)		
{
   _xdat float stepsize,vcom_min, Vnew,flicker_data;
   _xdat int j,k;
  _xdat char *pbuf;
  _xdat	unsigned char data_flk[7]= "*flick#";
 	  unsigned char data_flicker[13]= "*gmt#flicker!";
	
	vcom_min = -0.4;
		
//	InitPanPot(0, 0, 100);	// PanPot number, min value, max value for the switch on operator panel
			do
		{
			Clear_Screen();
	 		Display_Message("VCOM trimming");
	 		Display_Message("Press Start Button to pass VCOM trimming");
			 flicker_data = read_flick();
			 Wait(10);     //ȴʱ䲻ܵ10.
            Display_Float("flick=%3f",flicker_data);
			 for(j=0;j<7;j++)
	         {
	           uart_putchar(data_flk[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&flicker_data;
		  for(k=0;k<4;k++)
//		  for(k=4;k>0;k--)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	 Wait(send_wait);

			if(flicker_data > 0.05)
			    {
				YellowPanLed(2);
			   	GreenPanLed(0);
				}
			else
			    {
	     	    GreenPanLed(1);
				YellowPanLed(0);
			  	 }
			Wait(100);

	   }
	   while(Start_Pressed()==0);
	   flicker_data = read_flick();
	   Wait(20);
	   read_rgb2(&X,&Y,&Z);	// һҪִdatalog
//////////////////////flicker value datalog////////////////////////////
	   			 for(j=0;j<13;j++)
	           {
	           uart_putchar(data_flicker[j]);
	           }
//			 Wait(100);
	     	pbuf = (char *)&flicker_data;
		  for(k=0;k<4;k++)
//		  for(k=4;k>0;k--)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	 Wait(send_wait);
 }

//*************************************************************************************
//			MAIN 	MAIN 	MAIN 	MAIN 	MAIN
//*************************************************************************************
void TestProgram(void)
{
	 _xdat float 	Test;
	 _xdat float Rx,Ry,Gx,Gy,Bx,By,Wx,Wy,W_Y,BLx,BLy,BL_Y, flicker_data,CR;
	 _xdat	int j,k;
  	  char *pbuf;
	//float rgb_value[3];
	 unsigned char data_redx[11]= "*gmt#red_x!";
    unsigned char data_redy[11]= "*gmt#red_y!";
	unsigned char data_redX[11]= "*gmt#red_X!";
    unsigned char data_redY[11]= "*gmt#red_Y!";
	unsigned char data_redZ[11]= "*gmt#red_Z!";
    unsigned char data_greenx[13]= "*gmt#green_x!";
	unsigned char data_greeny[13]= "*gmt#green_y!";
	unsigned char data_greenX[13]= "*gmt#green_X!";
	unsigned char data_greenY[13]= "*gmt#green_Y!";
	unsigned char data_greenZ[13]= "*gmt#green_Z!";
    unsigned char data_bluex[12]= "*gmt#blue_x!";
    unsigned char data_bluey[12]= "*gmt#blue_y!";
	unsigned char data_blueX[12]= "*gmt#blue_X!";
	unsigned char data_blueY[12]= "*gmt#blue_Y!";
    unsigned char data_blueZ[12]= "*gmt#blue_Z!";	    	
 	unsigned char data_whitex[13]= "*gmt#white_x!";
	unsigned char data_whitey[13]= "*gmt#white_y!";
	unsigned char data_whiteX[13]= "*gmt#white_X!";
	unsigned char data_whiteY[13]= "*gmt#white_Y!";
	unsigned char data_whiteZ[13]= "*gmt#white_Z!";
 	unsigned char data_blackx[13]= "*gmt#black_x!";
	unsigned char data_blacky[13]= "*gmt#black_y!";
	unsigned char data_blackX[13]= "*gmt#black_X!";
	unsigned char data_blackY[13]= "*gmt#black_Y!";
	unsigned char data_blackZ[13]= "*gmt#black_Z!";
 	unsigned char data_start[11]= "*gmt#start!";
 	unsigned char data_fail[16]= "*gmt#status!FAIL";
 	unsigned char data_pass[16]= "*gmt#status!PASS";
 	unsigned char data_CR[8]= "*gmt#CR!";
 	unsigned char data_flk[7]= "*flick#";
 	unsigned char data_PName[19]= "*gmt#PName!DJ035xxx";
 
	  	Reset_Power();

//*************************************************************************************

		Display_Message("Continuity Loop");
		Out_Dac(LOOP1, 1.8);
		Wait(1000);
		Out_Dac(LOOP1, 0);

		Display_Message("NTC Test");
		Init_Power();
    	Init_Protocol(rgb);

		first_flag=1;								// display of first test pattern

	    Wait(200);
		 uart_init();	  
			 Wait(100);
		   for(j=0;j<11;j++)
              {
               uart_putchar(data_start[j]);
              }
			 Wait(200);
		   for(j=0;j<19;j++)
		     {
		       uart_putchar(data_PName[j]);
		     }	   
			Wait(200);

	  Display_Message("adjust flicker");
	  Display_Bitmap(rgb,flicker_dot);	
	   Wait(300);
	   flicker_measure();	

       Display_Message("color point measure");
		Display_Message("1-Red");
	  	Display_Bitmap(rgb,red);				
	    Wait(200);
		// OpticsTest();
		read_rgb2(&X,&Y,&Z);
 		    Rx = X/(X+Y+Z);
	     	Ry = Y/(X+Y+Z);
//////////////////////////red/////////////////////////////
 		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }  
		    Wait(send_wait);
//        if(Test_Float("R_X= %f",X,0,620))
         Test_Float("R_X= %f",X,60,1000);

//		   {Display_Message("R_X out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
 //		  if(Test_Float("R_Y= %f",Y,0,657))
	      Test_Float("R_Y= %f",Y,0,1000);		
//		   {Display_Message("R_Y out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
         Test_Float("R_Z= %f",Z,0,1000);
//         if(Test_Float("R_Z= %f",Z,0,657))
//		   {Display_Message("R_Z out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redx[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Rx;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
		 if(Test_Float("Rx= %f",Rx,0.575,0.675))
		   {Display_Message("Rx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
				 goto end;
		   }		
	 	  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redy[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Ry;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	 Wait(send_wait);
          if(Test_Float("Ry= %f",Ry,0.304,0.404))
		   {Display_Message("Ry out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
			    goto end;
		   }

		Clear_Screen();
		//////////////////////////////green/////////////////////////
	   	Display_Message("2-Green");
	  	Display_Bitmap(rgb,green);				
	    Wait(200);
  	      read_rgb2(&X,&Y,&Z);

 	    	Gx = X/(X+Y+Z);
		    Gy = Y/(X+Y+Z);
        
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
		  Test_Float("G_X= %f",X,0,1000);
//		   {Display_Message("G_X out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
        
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
     	    Wait(send_wait);
		  Test_Float("G_Y= %f",Y,0,1000);
//		   {Display_Message("G_Y out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
       
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
		   Test_Float("G_Z= %f",Z,0,1000);
//		   {Display_Message("G_Z out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
		
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenx[j]);
	         }
//		   Wait(100);
	     	pbuf = (char *)&Gx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
	     if(Test_Float("Gx= %f",Gx,0.277,0.377))
		   {Display_Message("Gx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
				 goto end;
		   }  
		
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greeny[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Gy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
         if(Test_Float("Gy= %f",Gy,0.528,0.628))
		   {Display_Message("Gy out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
			    goto end;
		   }
		Wait_Halt(10);
		Clear_Screen();
///////////////////////////blue///////////////////////
	   	Display_Message("3-Blue");
	  	Display_Bitmap(rgb,blue);				
	    Wait(200);
       read_rgb2(&X,&Y,&Z);
 		    Bx = X/(X+Y+Z);
		    By = Y/(X+Y+Z);
	   	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
		  Test_Float("B_X= %f",X,0,1000);
//		   {Display_Message("B_X out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	   	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
          Test_Float("B_Y= %f",Y,0,1000);
//		   {Display_Message("B_Y out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	  	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
           Test_Float("B_Z= %f",Z,0,1000);
//		   {Display_Message("B_Z out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	 	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_bluex[j]);
	         }
//			Wait(100);
	     	pbuf = (char *)&Bx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
		if(Test_Float("Bx= %f",Bx,0.093,0.193))
		   {Display_Message("Bx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
				 goto end;
		   }
	//	Wait(100);

	  	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_bluey[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&By;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
		if(Test_Float("By= %f",By,0.021,0.121))        
		   {Display_Message("By out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
			    goto end;
		      }
		Wait_Halt(10);
				Clear_Screen();
///////////////////////////white////////////////////////	   	   	
	   	Display_Message("4-White");
	  	Display_Bitmap(rgb,white);				
	    Wait(200);
//  	        OpticsTest();
		read_rgb2(&X,&Y,&Z);

 	     	Wx = X/(X+Y+Z);
	     	Wy = Y/(X+Y+Z);
			W_Y = Y;
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	  Wait(send_wait);
          Test_Float("W_X= %f",X,0,1000);
//		   {Display_Message("W_X out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
          if(Test_Float("W_Y= %f",Y,250,400))
		   {Display_Message("W_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
				    Wait(200);
	             }
				ErrorPanLed(1);
				 goto end;
		   }

	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
         Test_Float("W_Z= %f",Z,0,1000);
//		   {Display_Message("W_Z out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whitex[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Wx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
	   		    Wait(send_wait);
		if(Test_Float("Wx= %f",Wx,0.268,0.368))
		   {Display_Message("Wx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
				 goto end;
		   }
	 
	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whitey[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Wy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
		if(Test_Float("Wy= %f",Wy,0.28,0.38))        
		   {Display_Message("Wy out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				   Wait(200);
	             }
				ErrorPanLed(1);
			    goto end;
		   }

///////////////////////////black///////////////////////
	   	Display_Message("5-Black");
	  	Display_Bitmap(rgb,black);				
	    Wait(200);
		read_rgb2(&X,&Y,&Z);

 	    	BLx = X/(X+Y+Z);
	    	BLy = Y/(X+Y+Z);
			BL_Y = Y;
			CR = W_Y/BL_Y;
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
        Test_Float("BL_X= %f",X,0,600);
//         {Display_Message("BL_X out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }
//
	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
          Test_Float("BL_Y= %f",Y,0,657);
//		   {Display_Message("BL_Y out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
        Test_Float("BL_Z= %f",Z,0,657);
//		   {Display_Message("BL_Z out of limit");
//              for(j=0;j<16;j++)
//	             {
//	               uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackx[j]);
	         }
//			Wait(100);
	     	pbuf = (char *)&BLx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
//		if(Test_Float("BLx= %f",BLx,0,1))
//		   {Display_Message("BLx out of limit");
//		      for(j=0;j<16;j++)
//	             {
//	              uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//				 goto end;
//				Wait(300);
//		   }

	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blacky[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&BLy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
//		if(Test_Float("BLy= %f",BLy,0,1))        
//		   {Display_Message("BLy out of limit");
//              for(j=0;j<16;j++)
//	             {
//	              uart_putchar(data_fail[j]);
//	             }
//				ErrorPanLed(1);
//			    goto end;
//				Wait(300);
//		   }		
//		Wait_Halt(10);	 
		    for(j=0;j<8;j++)
	         {
	           uart_putchar(data_CR[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&CR;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
		if(Test_Float("CR= %f",CR,150,6000))        
		   {Display_Message("CR out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
				  Wait(200);
	             }
				ErrorPanLed(1);
			    goto end;
		   }

//		Wait_Halt(10);
//				Clear_Screen();
				 for(j=0;j<16;j++)
		     {
		       uart_putchar(data_pass[j]);
		     }
		Wait(100);
				Clear_Screen();
							  
 end:		

//*************************************************************************************
   	   	Reset_Power();
		Display_Message("Test Ended");
}

