/* 								  
 *
 *  	FILENAME: 			P9143 LTPS FM
 *
 *  	DRIVER:    			L1K0
 *    	DESCRIPTION:	    Full Module Program P9143 LTPS digital 3.5"
 *
 *    	AUTHOR:				Conrad Ching
 *    	HISTORY:    		
 * 		Ver2.a			  	FMT program is use already, change project name from P9143 to P9457
 *		Ver3.a				pattern change automatically, pause by halt_button
 *
 *
 * 
 *      
 *************************************************************************************/
rom unsigned char Program12nc[] = "521000205A";
rom unsigned char Project[] = "P9457 FMT Ver3.a";
rom unsigned char Date[] = "20090710";

#include "TestProgramV2_1_1.h"
extern float  X,Y,Z;
#define interface	rgb
//*************************************************************************************
// Control lines
//*************************************************************************************
#define CLK			Ocont_0
#define DE			Ocont_1
#define HS			Ocont_2
#define VS			Ocont_3
#define send_wait       250

//*************************************************************************************
// Data lines
//*************************************************************************************
#define D0	  		IOdata_0		 //R0	 A5 
#define D1	  		IOdata_1		 //R1	 B5
#define D2	  		IOdata_2		 //R2	 A6
#define D3	  		IOdata_3		 //R3	 B6
#define D4	  		IOdata_4  		 //R4	 A7
#define D5	  		IOdata_5		 //R5	 B7
#define D6	  		IOdata_6  		 //G0	 A8
#define D7	  		IOdata_7		 //G1	 B8
#define D8	  		IOdata_8  		 //G2	 A9
#define D9	  		IOdata_9		 //G3	 B9
#define D10	  		IOdata_10		 //G4	 A10
#define D11	  		IOdata_11  		 //G5	 B10
#define D12	  		IOdata_12		 //B0	 A11
#define D13	  		IOdata_13  		 //B1	 B11
#define D14	  		IOdata_14		 //B2	 A12
#define D15	  		IOdata_15		 //B3	 B12
#define D16	  		Odata_16  		 //B4	 A13
#define D17	  		Odata_17		 //B5	 B13
#define RL			Odata_19		 //High = D1 -> D320
#define TB			Odata_21		 //High = Top -> Bottom

#define CSB			Odata_20
#define SCL			Odata_23
#define SDA			Odata_22

#define BL_EN		SlowIO_7		//backlight enable H=enable L=disable
#define DIM			Ocont_4			//dimming control
#define NTC			Odata_18		// NTC pin

#define ALLIODATA1	0xFFFFFF 

//*************************************************************************************
// Analog outputs
//*************************************************************************************
#define VDD				Vout_4
#define I_VDD			I_Vout4
#define I_BL			Ain16
#define V_BL			Ain15
#define SHUNT_R			0.41		// Two 0.82 ohm resistor in parallel
									// Farnell order code: 3104709

//*************************************************************************************
//   OUTPUT values Hardware
//*************************************************************************************
#define vdd			3.3
#define VOPEN		-0.65
#define	VTRESHOLD	1.1

//*************************************************************************************
//	Limits for current measurements TFT
//*************************************************************************************
#define    	idd_por_min					5E-6   		// 		         
#define    	idd_por_max					200E-6  	//
#define 	i_led_min					120E-3
#define		i_led_max					300E-3 		 

#define		i_flicker_min				30.2E-3
#define		i_flicker_max				45.2E-3
#define		i_frame_min					28.5E-3
#define		i_frame_max					47.4E-3
#define		i_red_min					27.1E-3
#define		i_red_max					46.3E-3
#define		i_green_min					27.1E-3
#define		i_green_max					46.4E-3
#define		i_blue_min					29.4E-3
#define		i_blue_max					48.2E-3
#define		i_black_min					28.6E-3
#define		i_black_max					47.4E-3
#define		i_white_min					26.5E-3
#define		i_white_max					44.1E-3
#define		i_h_grey_bars_min			28.3E-3
#define		i_h_grey_bars_max			46.3E-3
#define		i_v_grey_bars_min			28.0E-3
#define		i_v_grey_bars_max			45.6E-3
#define		i_h_color_bars_min			28.5E-3
#define		i_h_color_bars_max			47.1E-3
#define		i_v_color_bars_min			29.0E-3
#define		i_v_color_bars_max			45.7E-3
#define		i_chess_min					31.0E-3
#define		i_chess_max					51.0E-3
#define		i_checker_flag_min			28.1E-3
#define		i_checker_flag_max			45.6E-3
#define 	i_module_min				31.0E-3
#define 	i_module_max				51.0E-3

#define		NTC_min						249E-6		// at 18deg C
#define		NTC_max						2.0E-3		// at 80deg C

//*************************************************************************************
// input short and open limits
//*************************************************************************************
#define	ISHORT_LOW_OFS_MIN			   	-2000E-6 
#define	ISHORT_LOW_OFS_MAX			  	2000E-6 
#define	ISHORT_LOW_REL_MIN			   	-2000E-6 
#define	ISHORT_LOW_REL_MAX			  	2000E-6 
#define	ISHORT_HIGH_OFS_MIN			   	-2000E-6 
#define	ISHORT_HIGH_OFS_MAX			  	2000E-6 
#define	ISHORT_HIGH_REL_MIN			   	-2000E-6 
#define	ISHORT_HIGH_REL_MAX			  	2000E-6 
#define	IOPEN_MIN			   			-2000E-6 
#define	IOPEN_MAX			  			2000E-6 

//********************************************************************************
// Global Variable
//********************************************************************************
unsigned int reg_data;

//********************************************************************************
// Definition of displays
//********************************************************************************
unsigned char xdat rgb[32];  
unsigned char xdat rgb_high[32];
unsigned char xdat rgb_low[32];
unsigned char xdat rgb655[32];  
unsigned char xdat rgb556[32];  

//********************************************************************************
// Definition of bitmaps
//********************************************************************************
unsigned char xdat spi[32];
unsigned char xdat no_clk[32];
unsigned char xdat unicolor[32];
unsigned char xdat unicolor_low[32];
unsigned char xdat unicolor_high[32];
unsigned char xdat bird[32];
unsigned char xdat flicker_dot[32];
unsigned char xdat frame[32];
unsigned char xdat red[32];   
unsigned char xdat green[32];
unsigned char xdat blue[32];   
unsigned char xdat black[32];   
unsigned char xdat white[32];   
unsigned char xdat h_grey_bars[32];
unsigned char xdat v_grey_bars[32];
unsigned char xdat h_color_bars[32];
unsigned char xdat v_color_bars[32];
unsigned char xdat chess[32];
unsigned char xdat checker_flag[32];
unsigned char xdat strip[32];
unsigned char xdat h_grey_color_bars[32];
unsigned char xdat v_grey_color_bars[32];
/*
unsigned char xdat grey15[32];
unsigned char xdat grey31[32];
unsigned char xdat grey47[32];
unsigned char xdat half_red[32];   
unsigned char xdat half_green[32];
unsigned char xdat half_blue[32];   
unsigned char xdat window[32];
unsigned char xdat flicker_line[32];
*/
									
//********************************************************************************
void Initialise_Names(void)
{
    romstrcpy( rgb	  		, "p9143" );
    romstrcpy( bird			, "320x240_bird.bmp" );

    romstrcpy( flicker_dot	, "320x240_flicker_dot.bmp" );
    romstrcpy( frame		, "320x240_frame.bmp" );
    romstrcpy( red 			, "320x240_red.bmp" );
    romstrcpy( green		, "320x240_green.bmp" );
    romstrcpy( blue		    , "320x240_blue.bmp" );
    romstrcpy( black 		, "320x240_black.bmp" );
    romstrcpy( white		, "320x240_white.bmp" );
    romstrcpy( h_grey_bars		, "320x240_h_64grey_bars.bmp" );
    romstrcpy( v_grey_bars		, "320x240_v_64grey_bars.bmp" );
    romstrcpy( h_color_bars		, "320x240_h_color_bars.bmp" );
    romstrcpy( v_color_bars		, "320x240_v_color_bars.bmp" );
    romstrcpy( chess			, "320x240_chess.bmp" );
    romstrcpy( checker_flag		, "320x240_checker_flag.bmp" );
    romstrcpy( strip			, "320x240_strip.bmp" );
/*  romstrcpy( h_grey_color_bars, "320x240_h_grey_color_bars.bmp" );
    romstrcpy( v_grey_color_bars, "320x240_v_grey_color_bars.bmp" );
	romstrcpy( grey15			, "320x240_grey15.bmp" );
    romstrcpy( grey31			, "320x240_grey31.bmp" );
    romstrcpy( grey47			, "320x240_grey47.bmp" );
    romstrcpy( half_red  		, "320x240_half_red.bmp" );
    romstrcpy( half_green		, "320x240_half_green.bmp" );
    romstrcpy( half_blue    	, "320x240_half_blue.bmp" );
    romstrcpy( window			, "320x240_window.bmp" );
    romstrcpy( flicker_line		, "320x240_flicker_line.bmp" );
*/ 
}

//********************************************************************************
void Init_Power(void)
{
 	Out_Dac(VDD,vdd);
   	Out_Dac(V_Low,0);
	Out_Dac(V_High,vdd);
 	Set_Slow(BL_EN);
 	Wait(100);
}
//********************************************************************************
void Reset_Power(void)
{
	Reset_Slow(BL_EN);
    Out_Dac(VDD,0);
    Out_Dac(V_Low,0);
    Out_Dac(V_High,0);
    Wait(100);
}
//********************************************************************************
signed char Init_Protocol(unsigned char xdat *Driver_Name)
{

	if (!strcmp(Driver_Name, rgb))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 							// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM); 	//Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("7.5MHz");
    }
    else if (!strcmp(Driver_Name, rgb_low))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(6000);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 384;									// Total number of clock pulses per line
		iRgblinesFrame = 260;									// Total number of lines within frame
		cRgbHorPos = 24;										// Horizontal start position of display line
		cRgbVerPos = 3; 										// Vertical start position of display line
		cRgbHorSync = 3;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 1;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("6.0MHz");
    }
    else if (!strcmp(Driver_Name, rgb_high))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(8890);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 436;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 100;										// Horizontal start position of display line
		cRgbVerPos = 20; 										// Vertical start position of display line
		cRgbHorSync = 80;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 3;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("8.89MHz");
    }
    else if (!strcmp(Driver_Name, unicolor))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);
    }
    else if (!strcmp(Driver_Name, unicolor_low))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(6000);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 384;									// Total number of clock pulses per line
		iRgblinesFrame = 260;									// Total number of lines within frame
		cRgbHorPos = 24;										// Horizontal start position of display line
		cRgbVerPos = 3; 										// Vertical start position of display line
		cRgbHorSync = 3;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 1;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);

		Display_Message("6MHz unicolor");
		Wait(800);
    }
    else if (!strcmp(Driver_Name, unicolor_high))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 	// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM);					// Idle stuation is high

		SetFrequency(8890);
		cProtocol = cProtocol_RGB;								// Define protocol
		  		
  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines
  		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 436;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 100;										// Horizontal start position of display line
		cRgbVerPos = 20; 										// Vertical start position of display line
		cRgbHorSync = 80;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 3;	 									// Duration of Vertical sync in lines

  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+DIM+CSB+SCL+SDA+TB+RL);						// Switch all lines to protocol
		SetDigital(CSB+SCL);
		ResetDigital(SDA+TB+RL);
	
		Display_Message("8.89MHz unicolor");
		Wait(800);
    }
	else if (!strcmp(Driver_Name, no_clk))
    {
        SelectDigitalSoftwareControl(ALLIODATA); 							// Switch all lines to software
  		
		OutputDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17+CSB+SCL+SDA+DIM); 	//Idle stuation is high

		SetFrequency(7500);
		cProtocol = cProtocol_RGB;											// Define protocol

  		cRgbCtrlReg = !RGB_VSYNC + !RGB_HSYNC + !RGB_CLOCK + RGB_ENABLE;		// Define polarity of control lines

		// MM Driving
 		iRgbPixelsX = 320;										// Number of display pixels horizontal
		iRgbPixelsY = 240;										// Number of display pixels vertical
		iRgbClocksLine = 424;									// Total number of clock pulses per line5
		iRgblinesFrame = 340;									// Total number of lines within frame
		cRgbHorPos = 54;										// Horizontal start position of display line
		cRgbVerPos = 12; 										// Vertical start position of display line
		cRgbHorSync = 51;	 									// Duration of Horizontal sync in clock pulses
		cRgbVerSync = 2;	 									// Duration of Vertical sync in lines
  		cColorExpansion = c565_666;

        SelectDigitalSoftwareControl(DIM+CSB+SCL+SDA+TB+RL+CLK);						// Switch lines to protocol
		SetDigital(CSB+SCL+DIM);
		ResetDigital(SDA+TB+RL);

	   	Display_Message("no clk Init");
    }
	else if (!strcmp(Driver_Name, spi))
    {
		EnableInput(0,0);
		OutputDigital(CSB+SCL+SDA+DIM);
		SelectDigitalSoftwareControl(ALLIODATA);
		lEnable_SCE = CSB;
		lEnable_DC = 0;
		lEnable_CLK = SCL;
		lEnable_DAT = SDA;
		lEnable_INDAT = 0;
		cProtocol = cProtocol_Serial_Word;
		cSerialCtrlReg = CS_LOW + CLOCK_UP + CLOCKIDLE_HIGH + MSB_FIRST + DC_AFTERDATA + DATA_COMNOT + NOSERIAL_DC;
//		cSerialCtrlReg = 0x29;
		cNrSerialBits = 16;
//		SetFrequency(1000);					// 500kHz SCL
		SetFrequency(160);					// 80kHz SCL
		SelectDigitalSoftwareControl(!CSB+!SCL+!SDA+DIM+CLK);
		
		Display_Message("spi init");
	}
    else
    {
        Display_Message("Wrong Driver Name in Init_protocol");
        return -1;
    }
    return 0;
}
//********************************************************************************
signed char Reset_Driver(unsigned char xdat *Driver_Name)
{
    if (!strcmp(Driver_Name, interface))
    {
        
    }
    else
    {
        Display_Message("Wrong Driver Name in Reset_Driver");
        return -1;
    }
    return 0;
}
//*************************************************************************************
signed char Init_Driver(unsigned char xdat * Driver_Name)
{   
    if (!strcmp(Driver_Name, interface))
    {
        	
    } 
    else
    {
        Display_Message("Wrong Driver Name in Init_Driver");
        return -1;
    }
    return 0;

} 

//*************************************************************************************
signed char Display_Bitmap(unsigned char xdat *Display_Name,unsigned char xdat *Bitmap_Name)
{
    struct bitmapheader xdat *Header;
    if (!Program_Aborted)
    {
        if ((Header = Select_Ram_Bitmap(Display_Name,Bitmap_Name)))
        {
 		     Start_Bitmap();
			 SetDigital(DIM);
        }
        else
        {
            Display_Message ("Unknown display or bitmap");
            return -1;
        }
    }
    return 0;
}

//*************************************************************************************
void Display_UniColor(unsigned char Red,unsigned char Green, unsigned Blue)
{
	#define LSBRedBit   0x100000	// points to the LSB of the Red color
	#define LSBGreenBit 0x004000	// points to the LSB of the Green color
	#define LSBBlueBit  0x000100	// points to the LSB of the Blue color

	long Result;

	Init_Protocol(unicolor);
	Result = (long)Red*LSBRedBit + (long)Green*LSBGreenBit + (long)Blue*LSBBlueBit; 
	ResetDigital(D0+D1+D2+D3+D4+D5+D6+D7+D8+D9+D10+D11+D12+D13+D14+D15+D16+D17);
	SetDigital(Result);
}

//*************************************************************************************
//   Module Current Test
//*************************************************************************************
//*************************************************************************************
float Module_Current_Test(void)  //Measure V_SUP; (VMOD)
{
   	float Test;
	Wait(300);
	Test = In_Adc(I_VDD,334);
	return Test;
}

//*************************************************************************************
//   Backlight Test measure current of internal backlight supply  
//   current of inverter not stable : more samples to measure avarage value over 300 x 100 us 
//*************************************************************************************
float Backlight_Ext_Current_Test(void)  //Measure opto channels;
{
   	float Test,Test1,Test2;
	Test1 =	In_Adc(I_BL,334);
	Test2 = In_Adc(V_BL,334);
	Test=(Test1-Test2)/SHUNT_R;
	return Test;
}


//*************************************************************************************
//	spi command to set driver IC register to meet MM timing
//*************************************************************************************
/*
void send_spi(void)
{
		Init_Protocol(spi);
		Send_Data(0x0102);			
		Send_Data(0x0210);
		Send_Data(0x030c);
		Send_Data(0x0436);			
		Send_Data(0x0500);
		Send_Data(0x0601);			
		Send_Data(0x0709);
		Send_Data(0x0800);
		Send_Data(0x0903);
		Send_Data(0x0a00);
		Send_Data(0x0b08);
		Send_Data(0x0c43);			
		Send_Data(0x0d00);
		Send_Data(0x0ef0);
		Send_Data(0x0f01);
		Send_Data(0x10b4);
		Send_Data(0x1120);
		Send_Data(0x1220);
		Send_Data(0x1320);			
		Send_Data(0x1410);
		Send_Data(0x1510);			
		Send_Data(0x1610);
		Send_Data(0x202d);
		Send_Data(0x210a);
		Send_Data(0x2211);
		Send_Data(0x2322);
		Send_Data(0x2400);
		Send_Data(0x2514);
		Send_Data(0x2600);
		Send_Data(0x27da);
		Send_Data(0x2800);
		Send_Data(0x2905);
		Send_Data(0x2a47);
		Send_Data(0x2b70);
		Send_Data(0x2c70);
		Send_Data(0x2d00);
		Send_Data(0x2e56);
		Send_Data(0x2fab);			
		Send_Data(0x3000);
		Send_Data(0x3133);
		Send_Data(0x3289);
		Send_Data(0x33f9);
		Send_Data(0x3475);
		Send_Data(0x35bd);
		Send_Data(0x36f7);
		Send_Data(0x3759);
		Send_Data(0x3896);
		Send_Data(0x39c8);
		Send_Data(0x3afb);
		Send_Data(0x3bff);
		Display_Message("spi finished");
}

void read_reg(unsigned int value)
{
	unsigned char temp;
	long read_back;
	bit d7, d6, d5, d4, d3, d2, d1, d0;

	temp = (unsigned char) value;
	ResetDigital(CSB);
//	if (temp & 0x80) SetDigital(SDA); else ResetDigital(SDA);
	SetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x40) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x20) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x10) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x08) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x04) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x02) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x01) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();

	if (read_back & 0x40) d7=1; else d7=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d6=1; else d6=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d5=1; else d5=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d4=1; else d4=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d3=1; else d3=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d2=1; else d2=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d1=1; else d1=0;
	
	ResetDigital(SCL); SetDigital(SCL);
	read_back = InputDigital();
	if (read_back & 0x40) d0=1; else d0=0;

	SetDigital(CSB+SCL);
	ResetDigital(SDA);
	
	reg_data = d7*0x80 + d6*0x40 + d5*0x20 + d4*0x10 + d3*0x08 + d2*0x04 + d1*0x02 + d0*0x01;
	Display_Three_Longs("Register %0lx is %0lx.", value, reg_data, 0);
//	Display_Long("Register(hex) =%0lx", reg_data);

	Wait(1000);
}
*/
void write_reg(unsigned int value)
{
	unsigned char temp;

	temp = (unsigned char) (value>>8);
	ResetDigital(CSB);

	ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x40) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x20) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x10) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x08) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x04) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x02) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x01) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);

	temp = (unsigned char) value;
	if (temp & 0x80) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x40) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x20) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x10) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x08) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x04) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x02) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x01) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	
	SetDigital(CSB+SCL);
	ResetDigital(SDA);
}

void write_ckh(unsigned char value)
{
	unsigned char temp;

//	temp = (unsigned char) (value>>8);
	temp = 0x20;
	ResetDigital(CSB);

	ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x40) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x20) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x10) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x08) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x04) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x02) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x01) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);

	temp = (unsigned char) value;
	if (temp & 0x80) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x40) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x20) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x10) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x08) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x04) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x02) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	if (temp & 0x01) SetDigital(SDA); else ResetDigital(SDA);
	ResetDigital(SCL); SetDigital(SCL);
	
	SetDigital(CSB+SCL);
	ResetDigital(SDA);
}

void spi_fix_dim(void)
{
		if (Engineer_Pressed())
		{
			Display_Message("0B08, press start");
			Start_Button(0);
		}
		write_reg(0x0B08);
		if (Engineer_Pressed())
		{
			Display_Message("2010, press start");
			Start_Button(0);
		}
		write_reg(0x2010);			
		if (Engineer_Pressed())
		{
			Display_Message("2807, press start");
			Start_Button(0);
		}
		write_reg(0x2807);			

		Display_Message("dim fixed, press start");
		Start_Button(0);
}
/*
void choose_timing(void)
{
	    unsigned char Temp1; 
		unsigned char Temp2; 
//		float xdat freq; 

		Clear_Screen();
		Display_Message("press enter when ready");
		Display_Message("turn PanPot to choose timing");
		
		Temp1 = 99;
		InitPanPot(0, 0, 2);

		while(Start_Pressed());
		while(!Start_Pressed())
		{
			Temp2 = ReadPanPot(0);
	
			if (Temp1 != Temp2)
			{								
				Temp1 = Temp2;
//		 	    Clear_Screen();
				switch (Temp1)
				{
					case 0: 
					{
						Clear_Screen();
						Init_Protocol(unicolor);
						Display_UniColor(0, 31, 0);
						break;
					}
					case 1: 
					{
						Clear_Screen();
						Init_Protocol(unicolor_low);
						Display_UniColor(31, 0, 0);
						break;
					}
					case 2:
					{
						Clear_Screen();
						Init_Protocol(unicolor_high);
						Display_UniColor(0, 0, 31);
						break;
					}
					default: 
					{
						Clear_Screen();
						Init_Protocol(unicolor);
						Display_UniColor(0, 31, 0);
						break;
					}
				}
			}
		}
}
*/
//*************************************************************************************
/*
void grey_color_trimming(unsigned char color){

	    float xdat Temp1; 
		float xdat Temp2; 

		Temp1 = 0;
		InitPanPot(Temp1, -31, 32);

		while(Start_Pressed());
		while(!Start_Pressed())
		{
			Temp2 = ReadPanPot(0)+31;
	
			if (Temp1 != Temp2)
			{								
				Temp1 = Temp2;
				switch (color)
				{
					case 1: 
					{
						Display_UniColor(Temp1, 0, 0);
						Clear_Screen();
						Display_Integer("Grey Level=%3d", Temp1);				
						break;
					}
					case 2: 
					{
						Display_UniColor(0, Temp1, 0);
						Clear_Screen();
						Display_Integer("Grey Level=%3d", Temp1);				
						break;
					}
					case 3:
					{
						Display_UniColor(0, 0, Temp1);
						Clear_Screen();
						Display_Integer("Grey Level=%3d", Temp1);				
						break;
					}
					default: 
					{
						Display_UniColor(Temp1, Temp1, Temp1);
						Clear_Screen();
						Display_Integer("Grey Level=%3d", Temp1);				
						break;
					}
				}
			}
		}
}
*/
//*************************************************************************************

void ckh_trimming(void)
{
	    unsigned char Temp1; 
		unsigned char Temp2; 

		write_reg(0x0b08);

		Display_Message("ckh trim, press start");

		Temp1 = 0;
		InitPanPot(Temp1, -15, 32);

		while(Start_Pressed());
		while(!Start_Pressed())
		{
			Temp2 = ReadPanPot(0)+0x12;
	
			if (Temp1 != Temp2)
			{								
				Temp1 = Temp2;
		
				Display_Long("0x20=%0lx", Temp1);
/*				if (Engineer_Pressed())
				{
					Display_Message("press to write 0x20");
					Start_Button(0);
				}
*/
				write_ckh(Temp1);
			 }
		}
}

//*************************************************************************************
//			MAIN 	MAIN 	MAIN 	MAIN 	MAIN
//*************************************************************************************
void TestProgram(void)
{
		float 	Test;
		float Rx,Ry,R_Y,R_X,R_Z,Gx,Gy,G_X,G_Y,G_Z,Bx,By,B_X,B_Y,B_Z,Wx,Wy,W_X,W_Y,W_Z,BLx,BLy,BL_X,BL_Y,BL_Z,CR;
		int j,k;
  	char *pbuf;
	 unsigned char data_redx[11]= "*gmt#red_x!";
    unsigned char data_redy[11]= "*gmt#red_y!";
	unsigned char data_redX[11]= "*gmt#red_X!";
    unsigned char data_redY[11]= "*gmt#red_Y!";
	unsigned char data_redZ[11]= "*gmt#red_Z!";
    unsigned char data_greenx[13]= "*gmt#green_x!";
	unsigned char data_greeny[13]= "*gmt#green_y!";
	unsigned char data_greenX[13]= "*gmt#green_X!";
	unsigned char data_greenY[13]= "*gmt#green_Y!";
	unsigned char data_greenZ[13]= "*gmt#green_Z!";
    unsigned char data_bluex[12]= "*gmt#blue_x!";
    unsigned char data_bluey[12]= "*gmt#blue_y!";
	unsigned char data_blueX[12]= "*gmt#blue_X!";
	unsigned char data_blueY[12]= "*gmt#blue_Y!";
    unsigned char data_blueZ[12]= "*gmt#blue_Z!";	    	
 	unsigned char data_whitex[13]= "*gmt#white_x!";
	unsigned char data_whitey[13]= "*gmt#white_y!";
	unsigned char data_whiteX[13]= "*gmt#white_X!";
	unsigned char data_whiteY[13]= "*gmt#white_Y!";
	unsigned char data_whiteZ[13]= "*gmt#white_Z!";
 	unsigned char data_blackx[13]= "*gmt#black_x!";
	unsigned char data_blacky[13]= "*gmt#black_y!";
	unsigned char data_blackX[13]= "*gmt#black_X!";
	unsigned char data_blackY[13]= "*gmt#black_Y!";
	unsigned char data_blackZ[13]= "*gmt#black_Z!";
 	unsigned char data_start[11]= "*gmt#start!";
 	unsigned char data_fail[16]= "*gmt#status!FAIL";
 	unsigned char data_pass[16]= "*gmt#status!PASS";
 	unsigned char data_CR[8]= "*gmt#CR!";	
	  	Reset_Power();
/*		Display_Message("0-Input Scan");
		if (Open_Short_Test())
		{
			Reset_Power();
			ErrorPanLed(2);
		}
*/
		Init_Power();
		Wait(100);

  	    Init_Protocol(rgb);

//		TEST MODE
//*************************************************************************************
 /*		if (Engineer_Pressed())
		{												// bird check display, current
		    Clear_Screen();			
			Display_Message("Bird");
	  		Display_Bitmap(rgb,	bird);
			SetDigital(DIM);		
			Wait(200);
			Test=Module_Current_Test();
			if (Test_Float("I module(bird) = %5.2f  A",Test,i_module_min,i_module_max))
			{	
				Display_Message("Imod fails(bird)");
				ErrorPanLed(2);
				Wait(300);
			}
			Display_Message("Greyscale next...");
			while(!Start_Pressed());
			Clear_Screen();
		}	
		if (Engineer_Pressed())							// B/W, R, G, B greyscale
		{
			Display_Message("B/W Grey Scale");
			grey_color_trimming(0);
//			ckh_trimming();
			Clear_Screen();
			Display_Message("R Grey Scale");
			grey_color_trimming(1);
//			ckh_trimming();
			Clear_Screen();
			Display_Message("G Grey Scale");
			grey_color_trimming(2);
//			ckh_trimming();
			Clear_Screen();
			Display_Message("B Grey Scale");
			grey_color_trimming(3);
//			ckh_trimming();
			Clear_Screen();
//		 	while(!Start_Pressed());
		}
*/
//		NORMAL OPERATION
//*************************************************************************************
		Clear_Screen();
  	    Init_Protocol(rgb);
		SetDigital(DIM);
		 uart_init(); 
			 Wait(100);
		   for(j=0;j<11;j++)
              {
               uart_putchar(data_start[j]);
              }
			 Wait(100);	
		Display_Message("1-Red");
	  	Display_Bitmap(rgb,red);				
	    Wait(200);
		 OpticsTest();
 		    Rx = X/(X+Y+Z);
	     	Ry = Y/(X+Y+Z);
//////////////////////////red/////////////////////////////
 		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }  
		    Wait(send_wait);
        if(Test_Float("R_X= %f",X,0,620))
		   {Display_Message("R_X out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
		  if(Test_Float("R_Y= %f",Y,0,657))	
		   {Display_Message("R_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
		  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
         if(Test_Float("R_Z= %f",Z,0,657))
		   {Display_Message("R_Z out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
			 for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redx[j]);
	         }
//			Wait(100);
	     	pbuf = (char *)&Rx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
		 if(Test_Float("Rx= %f",Rx,0.575,0.675))
		   {Display_Message("Rx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }		
	 	  for(j=0;j<11;j++)
	         {
	           uart_putchar(data_redy[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Ry;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	 Wait(send_wait);
          if(Test_Float("Ry= %f",Ry,0.304,0.404))
		   {Display_Message("Ry out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
//				Globe_Error=1;
			    goto end;
				Wait(300);
		   }
		Wait_Halt(10);

		Clear_Screen();
		//////////////////////////////green/////////////////////////
	   	Display_Message("2-Green");
	  	Display_Bitmap(rgb,green);				
	    Wait(200);
  	      OpticsTest();

 	    	Gx = X/(X+Y+Z);
		    Gy = Y/(X+Y+Z);
        
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
		   if(Test_Float("G_X= %f",X,0,600))
		   {Display_Message("G_X out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
        
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
     	    Wait(send_wait);
		  if(Test_Float("G_Y= %f",Y,0,657))
		   {Display_Message("G_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
       
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
		   if(Test_Float("G_Z= %f",Z,0,657))
		   {Display_Message("G_Z out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
		
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greenx[j]);
	         }
//		   Wait(100);
	     	pbuf = (char *)&Gx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
	     if(Test_Float("Gx= %f",Gx,0.277,0.377))
		   {Display_Message("Gx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }  
		
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_greeny[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Gy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
         if(Test_Float("Gy= %f",Gy,0.528,0.628))
		   {Display_Message("Gy out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
			    goto end;
				Wait(300);
		   }
		Wait_Halt(10);
		Clear_Screen();
///////////////////////////blue///////////////////////
	   	Display_Message("3-Blue");
	  	Display_Bitmap(rgb,blue);				
	    Wait(200);
       OpticsTest();
 		    Bx = X/(X+Y+Z);
		    By = Y/(X+Y+Z);
	   	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
		 if(Test_Float("B_X= %f",X,0,600))
		   {Display_Message("B_X out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	   	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
          if(Test_Float("B_Y= %f",Y,0,657))
		   {Display_Message("B_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	  	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_blueZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
        if(Test_Float("B_Z= %f",Z,0,657))
		   {Display_Message("B_Z out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	 	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_bluex[j]);
	         }
//			Wait(100);
	     	pbuf = (char *)&Bx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
		if(Test_Float("Bx= %f",Bx,0.093,0.193))
		   {Display_Message("Bx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
	//	Wait(100);

	  	  for(j=0;j<12;j++)
	         {
	           uart_putchar(data_bluey[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&By;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
		if(Test_Float("By= %f",By,0.021,0.121))        
		   {Display_Message("By out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
			    goto end;
				Wait(300);
		   }
		Wait_Halt(10);
				Clear_Screen();
///////////////////////////black///////////////////////
	   	Display_Message("4-Black");
	  	Display_Bitmap(rgb,black);				
	    Wait(200);
		OpticsTest();

 	    	BLx = X/(X+Y+Z);
	    	BLy = Y/(X+Y+Z);
			BL_Y = Y;
	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
        if(Test_Float("BL_X= %f",X,0,600))
         {Display_Message("BL_X out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
        if(Test_Float("BL_Y= %f",Y,0,657))
		   {Display_Message("BL_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
		    Wait(send_wait);
        if(Test_Float("BL_Z= %f",Z,0,657))
		   {Display_Message("BL_Z out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blackx[j]);
	         }
//			Wait(100);
	     	pbuf = (char *)&BLx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
		    Wait(send_wait);
		if(Test_Float("BLx= %f",BLx,0,1))
		   {Display_Message("BLx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_blacky[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&BLy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
		if(Test_Float("BLy= %f",BLy,0,1))        
		   {Display_Message("BLy out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
			    goto end;
				Wait(300);
		   }
		Wait_Halt(10);
///////////////////////////white////////////////////////	   	   	
	   	Display_Message("5-White");
	  	Display_Bitmap(rgb,white);				
	    Wait(200);
  	        OpticsTest();

 	     	Wx = X/(X+Y+Z);
	     	Wy = Y/(X+Y+Z);
			W_Y = Y;
			CR = W_Y/BL_Y;
	  	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteX[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&X;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	
	       	  Wait(send_wait);
        if(Test_Float("W_X= %f",X,0,600))
		   {Display_Message("W_X out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteY[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Y;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	   
		    Wait(send_wait);
          if(Test_Float("W_Y= %f",Y,250,400))
		   {Display_Message("W_Y out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }

	 	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whiteZ[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Z;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	  
		    Wait(send_wait);
         if(Test_Float("W_Z= %f",Z,0,657))
		   {Display_Message("W_Z out of limit");
              for(j=0;j<16;j++)
	             {
	               uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whitex[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Wx ;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }	 
	   		    Wait(send_wait);
		if(Test_Float("Rx= %f",Wx,0.268,0.368))
		   {Display_Message("Wx out of limit");
		      for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
				 goto end;
				Wait(300);
		   }
	 
	   	  for(j=0;j<13;j++)
	         {
	           uart_putchar(data_whitey[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&Wy;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
		if(Test_Float("Wy= %f",Wy,0.28,0.38))        
		   {Display_Message("Wy out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
			    goto end;
				Wait(300);
		   }
		    for(j=0;j<8;j++)
	         {
	           uart_putchar(data_CR[j]);
	         }
//			 Wait(100);
	     	pbuf = (char *)&CR;
		  for(k=0;k<4;k++)
		     {
		       uart_putchar(pbuf[k]);
	       	 }		
		    Wait(send_wait);
		if(Test_Float("CR= %f",CR,150,1000))        
		   {Display_Message("CR out of limit");
              for(j=0;j<16;j++)
	             {
	              uart_putchar(data_fail[j]);
	             }
				ErrorPanLed(1);
			    goto end;
				Wait(300);
		   }

		Wait_Halt(10);
				Clear_Screen();
				 for(j=0;j<16;j++)
		     {
		       uart_putchar(data_pass[j]);
		     }
		Wait(100);
				Clear_Screen();

 end:
//*************************************************************************************
   	   	Reset_Power();
		Display_Message("Test Ended");
}

